#!/sw/bin/perl

###############################################################################
##                                                                           ##
##    Copyright (c) 2000 by Steffen Beyer.                                   ##
##    All rights reserved.                                                   ##
##                                                                           ##
##    Use, modify and redistribute under the same terms as Perl itself.      ##
##                                                                           ##
###############################################################################

# Usage: niceformat [maxcol] file [files]

$maxcol = 78;

$maxcol = shift if ($ARGV[0] =~ /^[1-9][0-9]*$/);

FILE:
foreach $file (map( glob($_), @ARGV ))
{
    next FILE unless (-f $file);
    $/ = "\n"; # line mode
    unless (open(INPUT, "<$file"))
    {
        warn "unable to read '$file': $!\n";
        next FILE;
    }
    unless (rename($file,"$file.bak"))
    {
        warn "unable to rename '$file' to '$file.bak': $!\n";
        close(INPUT);
        next FILE;
    }
    unless (open(OUTPUT, ">$file.$$.tmp"))
    {
        warn "unable to write '$file.$$.tmp': $!\n";
        close(INPUT);
        next FILE;
    }
    while (defined($line = <INPUT>))
    {
        $line =~ s!\s+$!!;
        print OUTPUT "$line\n";
    }
    close(INPUT);
    close(OUTPUT);
    $/ = ""; # paragraph mode
    unless (open(INPUT, "<$file.$$.tmp"))
    {
        warn "unable to read '$file.$$.tmp': $!\n";
        unless (unlink("$file.$$.tmp"))
        {
            warn "unable to unlink '$file.$$.tmp': $!\n";
        }
        next FILE;
    }
    unless (open(OUTPUT, ">$file"))
    {
        warn "unable to write '$file': $!\n";
        close(INPUT);
        unless (unlink("$file.$$.tmp"))
        {
            warn "unable to unlink '$file.$$.tmp': $!\n";
        }
        next FILE;
    }
    LINE:
    while (defined($line = <INPUT>))
    {
        $line =~ s!\s+$!!;
        if ($line =~ /^\s/)
        {
            print OUTPUT "$line\n\n";
            next LINE;
        }
        $line =~ s!-\n(?=\w)!!g;
        $line =~ s!\s+! !g;
        while (length($line) > $maxcol)
        {
            $p = $maxcol;
            while (($p > 0) && (substr($line,$p,1) !~ /^\s$/)) { $p--; }
            if ($p > 0)
            {
                $left = substr($line,0,$p);
                $line = substr($line,$p);
                $left =~ s!\s+$!!;
                $line =~ s!^\s+!!;
            }
            else
            {
                $left = substr($line,0,$maxcol);
                $line = substr($line,$maxcol);
            }
            print OUTPUT "$left\n";
        }
        print OUTPUT "$line\n\n";
    }
    close(INPUT);
    close(OUTPUT);
    unless (unlink("$file.$$.tmp"))
    {
        warn "unable to unlink '$file.$$.tmp': $!\n";
    }
}

__END__

